(() => {
  const previousGetItem = window.Storage.prototype.getItem;
  localStorage.getItem = function (key) {
    if (key === "protected-functions") {
      return null;
    }
    return previousGetItem.call(localStorage, key);
  };
  const previousWindowGetItem = window.Storage.prototype.getItem;
  window.Storage.prototype.getItem = function (key) {
    if (key === "protected-functions") {
      return null;
    }
    return previousWindowGetItem.call(this, key);
  };

  const protectedFunctions = JSON.parse(
    previousGetItem.call(localStorage, "protected-functions") || "[]",
  );

  const customTimeout = window.setTimeout;
  window.setTimeout = function (handlers, timeout, ...rest) {
    if (timeout > 500 && !protectedFunctions.includes(handlers.toString())) {
      return customTimeout(handlers, 0, ...rest);
    }
    return customTimeout(handlers, timeout, ...rest);
  };
})();
